100 REMark *****************************************************************
110 REMark *                                                               *
120 REMark * BASIC Configuration Extensions (v1.13)                        *
130 REMark * by Oliver Fink    18/06/90                                    *
140 REMark *                                                               *
150 REMark * Jobname : BasConfig                                           *
160 REMark *                                                               *
170 REMark * Updated : 05/04/94 - Norman Dunbar                            *
180 REMark * Updated : 02/10/95 - Dilwyn Jones (added C_NAME$ and C_VERS$) *
190 REMark * Updated : 16/02/99 - Dilwyn Jones (larger display window)     *
200 REMark *                                                               *
210 REMark * QLib Information : no cmdline, no windows, no lines, no names *
220 REMark *                                                               *
230 REMark * assembler moduls : BasConfig_cfg         - by O.Fink          *
240 REMark *                    chbase_rext           - S.Goodwin          *
250 REMark *                    (QLib runtimes)                            *
260 REMark *                                                               *
270 REMark *****************************************************************
280 :
290 REMark $$asmb=flp1_chbase_rext,0,272
300 REMark $$asmb=flp1_basconfig_cfg,0,12
310 :
320 REMark * draw main window and title
330 OPEN #1,'con_2x1a0x0'
340 IF C_CODE(1) = 1 THEN
350   ch = 1 : OUTLN 500,248,4,2;4,4
360 ELSE
370   ch = 2 : OPEN #2,'con_2x1a0x0' : WINDOW #2;500,248,4,2
380 END IF
390 PAPER #ch;7  : BORDER #ch;1,0 : CLS #ch
400 PAPER #ch;92 : INK #ch;0
410 CHAR_INC #ch;6,12 : CLS #ch;3
420 PAPER #ch;7 : CURSOR #ch;130,1 : PRINT #ch;" Configuration Extensions Level 1 "
430 WINDOW 496,235,6,14 : PAPER 7 : INK 0 : BORDER 1,4 : CLS
440 BORDER 2 : CSIZE 0,0
450 :
460 REMark * print some information for the user
470 PRINT "This program, supplied by QLaboratories, produces a file that  "
480 PRINT "allows the use of the standard QJump Configuration program in  "
490 PRINT "conjunction with Q_Liberated SuperBASIC programs.             "
500 PRINT
510 PRINT 'Bug fix & LONG WORD handling by Norman Dunbar, 5th April 1994.'
520 PRINT
530 PRINT 'C_VERS$, C_NAME$ extensions by Dilwyn Jones, 2nd October 1995.'
540 PRINT\'Larger BasConfig display by  Dilwyn Jones, 16th February 1999.'
550 base = -1
560 :
570 REMark * repeat all this over and over again
580 REPeat all
590   IF base <> -1 THEN RECHP base
600   PRINT
610   :
620   REMark * enter total number of items
630   REPeat chk
640     nr$ = Accept$("Enter the total number of configuration items required for\your file or press ESC to quit","",5,0)
650     IF nr$ = CHR$(27) THEN EXIT all
660     nr_items = '0'&nr$
670     IF nr_items > 0 THEN EXIT chk
680     Pr_Error nr$&" - not possible"
690   END REPeat chk
700   :
710   REMark * allocate space and load binary file to append data
720   bin_file$ = DATAD$&"cfg_bin"
730   base = ALCHP(10240)
740   :
750   REPeat chk
760     IF FTEST(bin_file$) = 0 THEN EXIT chk
770     Pr_Error bin_file$&" - not found on data device"
780     IF Accept$("Insert disk into drive "&DATAD$&" and press return","",0,0)=CHR$(27) THEN NEXT all
790   END REPeat chk
800   bin_len = FLEN(\bin_file$)
810   LBYTES bin_file$,base
820   adr_list = base+bin_len
830   :
840   REMark * get software name
850   PRINT
860   sw_name$ = Accept$("Enter software name","",25,3)
870   IF sw_name$ = CHR$(27) THEN NEXT all
880   Pk_$ adr_list,sw_name$
890   :
900   REMark * get software version number
910   PRINT
920   sw_vers$ = Accept$("Enter software version","1.00",8,3)
930   IF sw_vers$ = CHR$(27) THEN NEXT all
940   Pk_$ adr_list,sw_vers$
950   adr_list = Even(adr_list)
960   :
970   REMark * position where relative pointer point to
980   adr_items = adr_list+12*nr_items+4
990   :
1000   REMark * select appropriate type of configuration item
1010   FOR item = 1 TO nr_items
1020     PRINT
1030     type = Select_It("Select type for item #"&item,"String\Char\Code\Select\Byte\Word\Long word")
1040     SELect ON type
1050       =0 : CFG_String
1060       =1 : CFG_Char
1070       =2 : CFG_Code
1080       =3 : Pr_Error "select - not implemented yet":item=item-1:NEXT item
1090       =4 : CFG_Values  8
1100       =5 : CFG_Values 10
1110       =6 : CFG_Values 12
1120       =27: NEXT all
1130     END SELect
1140   END FOR item
1150   Pk_W adr_list,-1
1160   :
1170   PRINT
1180   file_name$ = DATAD$
1190   REPeat chk
1200     file_name$ = Accept$("Enter file name where the binary configuration file\will be written to",file_name$,32,3)
1210     IF file_name$ = CHR$(27) THEN NEXT all
1220     ferr = FTEST(file_name$)
1230     IF ferr = -7 THEN EXIT chk
1240     SELect ON ferr
1250       =-20: Pr_Error "read only permitted"
1260       =0  : over_w$=Accept$(file_name$&" already exists\OK to overwrite ... Y/N","",1,-1)
1270             IF over_w$=='Y' THEN EXIT chk
1280       =-9 : Pr_Error "file or device in use"
1290     END SELect
1300   END REPeat chk
1310   SBYTES_O file_name$,base,adr_items-base
1320 END REPeat all
1330 :
1340 STOP
1350 :
1360 REMark ----- poke procedures -----------------------------------------
1370 :
1380 DEFine PROCedure Pk_B(adr,val)
1390   POKE adr,val : adr = adr + 1
1400 END DEFine Pk_B
1410 :
1420 DEFine PROCedure Pk_W(adr,val)
1430   adr = Even(adr)
1440   POKE_W adr,val : adr = adr + 2
1450 END DEFine Pk_W
1460 :
1470 DEFine PROCedure pk_l(adr,val)
1480   adr = Even(adr)
1490   POKE_L adr,val : adr = adr + 4
1500 END DEFine pk_l
1510 :
1520 DEFine PROCedure Pk_Wr(adr,val)
1530   adr = Even(adr)
1540   Pk_W adr,val - adr
1550 END DEFine Pk_Wr
1560 :
1570 DEFine PROCedure Pk_$(adr,s$)
1580   LOCal l,i
1590   l = LEN(s$)
1600   Pk_W adr,l
1610   FOR i = 1 TO l : Pk_B adr,CODE(s$(i))
1620   adr = Even(adr)
1630 END DEFine Pk_$
1640 :
1650 DEFine FuNction Even(x)
1660    IF x/2 <> INT(x/2) THEN RETurn x + 1 : ELSE RETurn x
1670 END DEFine Even
1680 :
1690 REMark ----- special config procedures ---------------------------------
1700 DEFine FuNction It_Desc
1710   LOCal loop1,desc$,desc1$
1720   desc_adr = Even(adr_items)
1730   STRIP 7
1740   PRINT "Enter description text for the item. Press return for a new"\"line, or ESC in a new line when ready>"\\
1750   desc$ = Accept$("","",62,3)
1760   REPeat loop1
1770     PRINT
1780     desc1$ = Accept$("","",62,3)
1790     IF desc1$ = CHR$(27) THEN EXIT loop1
1800     desc$ = desc$&CHR$(10)&desc1$
1810   END REPeat loop1
1820   Pk_$ adr_items,desc$
1830   RETurn desc_adr
1840 END DEFine It_Desc
1850 :
1860 DEFine PROCedure CFG_Values(type)
1870   LOCal b_val$,b_val,b_adr,type$,r1
1880   SELect ON type
1890     =8 : type$ = "byte" : r1 = 255
1900     =10: type$ = "word" : r1 = 65535
1910     =12: type$ = 'long' : r1 = 2.147483E9: REMark Not quite 2^31-1
1920   END SELect
1930   Pk_B adr_list,type
1940   PRINT
1950   Pk_B adr_list,CODE(Accept$("Type selection keystroke for the item","",1,-1))
1960   PRINT
1970   REPeat chk
1980     b_val$ = Accept$("Enter initial value for "&type$&" (0-"&r1&")","0",LEN(r1),0)
1990     IF b_val$ = CHR$(27) THEN RETurn
2000     b_val = "0" & b_val$
2010     SELect ON b_val = 0 TO r1 : EXIT chk
2020     Pr_Error b_val$&" - not possible"
2030   END REPeat chk
2040   PRINT
2050   b_adr = adr_items
2060   Value_Poke type, adr_items, b_val
2070   Pk_Wr adr_list,b_adr
2080   Pk_W adr_list,0 : Pk_W adr_list,0
2090   Pk_Wr adr_list,It_Desc
2100   REPeat chk
2110     b_val$ = Accept$("Enter minimum value allowed","0",LEN(r1),0)
2120     IF b_val$ = CHR$(27) THEN RETurn
2130     b_val = "0"&b_val$
2140     SELect ON b_val = 0 TO r1 : EXIT chk
2150     Pr_Error b_val$&" - not possible"
2160   END REPeat chk
2170   PRINT
2180   b_adr = adr_items
2190   Value_Poke type, adr_items, b_val
2200   Pk_Wr adr_list,b_adr
2210   REPeat chk
2220     b_val$ = Accept$("Enter maximum value allowed",r1,LEN(r1),0)
2230     IF b_val$ = CHR$(27) THEN RETurn
2240     b_val = "0"&b_val$
2250     SELect ON b_val = 0 TO r1 : EXIT chk
2260     Pr_Error b_val$&" - not possible"
2270   END REPeat chk
2280   Value_Poke type, adr_items, b_val
2290 END DEFine CFG_Values
2300 :
2310 DEFine PROCedure CFG_String
2320   LOCal s_adr,s_num,s_num$
2330   Pk_B adr_list,0
2340   PRINT
2350   Pk_B adr_list,CODE(Accept$("Type selection keystroke for the item","",1,-1))
2360   PRINT
2370   REPeat chk
2380     s_num$ = Accept$("Enter maximum length of the string","62",3,3)
2390     IF s_num$ = CHR$(27) THEN EXIT chk
2400     s_num = "0"&s_num$
2410     SELect ON s_num = 2 TO 62:EXIT chk
2420     Pr_Error s_num$&" - not possible"
2430   END REPeat chk
2440   PRINT
2450   s_adr = adr_items
2460   Pk_W adr_items, s_num +1
2470   STRIP 7 : PRINT "Enter default string>"\\
2480   s$ = Accept$("","",s_num,3)
2490   PRINT
2500   Pk_$ adr_items,s$
2510   FOR i = s_num-LEN(s$) TO s_num + 1 : Pk_B adr_items,32
2520   adr_items = Even(adr_items)
2530   Pk_Wr adr_list,s_adr
2540   Pk_W adr_list,0 : Pk_W adr_list,0
2550   Pk_Wr adr_list,It_Desc
2560   s_adr = adr_items
2570   Pk_W adr_items,Select_It("Special characteristics","strip spaces\do not strip spaces")
2580   Pk_Wr adr_list,s_adr
2590 END DEFine CFG_String
2600 :
2610 DEFine PROCedure CFG_Char
2620   LOCal c_adr,byte
2630   Pk_B adr_list,2
2640   PRINT
2650   Pk_B adr_list,CODE(Accept$("Type selection keystroke for the item","",1,-1))
2660   PRINT
2670   c_adr = adr_items
2680   Pk_B adr_items,CODE(Accept$("Type in default character","",1,-1))
2690   PRINT
2700   Pk_Wr adr_list,c_adr
2710   adr_items = Even(adr_items)
2720   Pk_W adr_list,0 : Pk_W adr_list,0
2730   Pk_Wr adr_list,It_Desc
2740   byte = 0
2750   byte = 1-Select_It("Select possible characteristics\non printable characters allowed","yes\no")
2760   PRINT
2770   byte = byte+2*(1-Select_It("digits allowed","yes\no"))
2780   PRINT
2790   byte = byte+4*(1-Select_It("lower case letters allowed","yes\no"))
2800   PRINT
2810   byte = byte+8*(1-Select_It("upper case letters allowed","yes\no"))
2820   PRINT
2830   byte = byte+16*(1-Select_It("other printable characters allowed","yes\no"))
2840   PRINT
2850   byte = byte+64*(1-Select_It("cursor characters allowed","yes\no"))
2860   PRINT
2870   c_adr = adr_items
2880   Pk_W adr_items,byte
2890   Pk_Wr adr_list,c_adr
2900 END DEFine CFG_Char
2910 :
2920 DEFine PROCedure CFG_Code
2930   LOCal c_adr
2940   Pk_B adr_list,4
2950   PRINT
2960   Pk_B adr_list,CODE(Accept$("Type selection keystroke for the item","",1,-1))
2970   PRINT
2980   REPeat chk
2990     c_val$ = Accept$("Enter default code value (0-255)","0",3,0)
3000     IF c_val$ = CHR$(27) THEN RETurn
3010     c_val = "0" & c_val$
3020     SELect ON c_val = 0 TO 255 : EXIT chk
3030     Pr_Error c_val$&" - not possible"
3040   END REPeat chk
3050   PRINT
3060   c_adr = adr_items
3070   Pk_B adr_items,c_val
3080   adr_items = Even(adr_items)
3090   Pk_Wr adr_list,c_adr
3100   Pk_W adr_list,0 : Pk_W adr_list,0
3110   Pk_Wr adr_list,It_Desc
3120   selkey = Select_It("Allow selection keystrokes","no\yes")
3130   PRINT
3140   x = 0
3150   adr_items = Even(adr_items)
3160   c_adr = adr_items
3170   REPeat loop2
3180     x = x + 1
3190     REPeat chk
3200       c_val$ = Accept$("Enter code (0-255) for selection #"&x&" or press ESC\to finish code list","0",3,0)
3210       IF c_val$ = CHR$(27) THEN EXIT loop2
3220       c_val = "0"&c_val$
3230       SELect ON c_val = 0 TO 255 : EXIT chk
3240       Pr_Error c_val$&" - not possible"
3250     END REPeat chk
3260     Pk_B adr_items,c_val
3270     PRINT
3280     IF selkey
3290       Pk_B adr_items,CODE(Accept$("Type code selection keystroke","",1,-1))
3300       PRINT
3310     ELSE
3320       Pk_B adr_items,0
3330     END IF
3340     Pk_$ adr_items,Accept$("Enter string for this code","",30,3)
3350     PRINT
3360     adr_items = Even(adr_items)
3370   END REPeat loop2
3380   Pk_W adr_items,-1
3390   Pk_Wr adr_list,c_adr
3400 END DEFine CFG_Code
3410 :
3420 DEFine PROCedure Value_Poke(type, addr, value)
3430   LOCal t
3440   t = type
3450   SELect ON t
3460     = 8: Pk_B addr, value
3470     =10: Pk_W addr, value
3480     =12: pk_l addr, value
3490   END SELect
3500 END DEFine Value_Poke
3510 :
3520 REMark ----- general functions ---------------------------------------
3530 DEFine FuNction Accept$(info$,deft$,max_len,range)
3540   LOCal first,x,loop,pos,xpos,ypos,key$(1),key,loop,chblk,rang(1)
3550   default$ = deft$
3560   SELect ON range
3570     =0   : rang(0) = 48 : rang(1) = 57
3580     =1   : rang(0) = 45 : rang(1) = 57
3590     =2   : rang(0) = 65 : rang(1) = 90
3600     =3,-1: rang(0) = 32 : rang(1) = 191
3610   END SELect
3620   PAPER 7 : INK 0
3630   IF info$ <> "" THEN
3640     REPeat loop
3650       x = "\" INSTR info$
3660       IF x = 0 THEN EXIT loop
3670       PRINT info$(1 TO x-1)
3680       info$ = info$(x+1 TO)
3690     END REPeat loop
3700     PRINT info$;"> ";
3710   END IF
3720   chblk = CHBASE(#1) : STRIP 4
3730   pos   = 1
3740   xpos  = PEEK_W(chblk+34) DIV PEEK_W(chblk+38)
3750   ypos  = PEEK_W(chblk+36) DIV PEEK_W(chblk+40)
3760   first = 1
3770   REPeat loop
3780     AT ypos,xpos : PRINT default$; : CLS 4
3790     AT ypos,xpos + pos - 1
3800     IF first = 0 AND range = -1 THEN EXIT loop
3810     CURSEN : key$ = INKEY$(#1,-1) : CURDIS
3820     key = CODE(key$)
3830     SELect ON key
3840       =27 : default$ = key$ : EXIT loop
3850       =10 : EXIT loop
3860       =192: IF pos > 1 THEN pos = pos - 1
3870       =200: IF pos <= LEN(default$) THEN pos = pos + 1
3880       =194: IF pos > 1 THEN
3890               IF pos < LEN(default$)
3900                 default$ = default$(1 TO pos-2)&default$(pos TO)
3910               ELSE
3920                 default$ = default$(1 TO pos-2)
3930               END IF
3940               pos = pos - 1
3950             END IF
3960       =202: IF LEN(default$) > 0 THEN
3970               IF pos<LEN(default$) THEN
3980                 default$ = default$(1 TO pos-1)&default$(pos+1 TO)
3990               ELSE
4000                 default$ = default$(1 TO pos-1)
4010               END IF
4020             END IF
4030       =rang(0) TO rang(1)
4040             IF first THEN default$ = ""
4050             IF LEN(default$) < max_len
4060               IF pos < LEN(default$)
4070                 default$ = default$(1 TO pos-1) & key$ & default$(pos TO)
4080               ELSE
4090                 default$ = default$ & key$
4100               END IF
4110               pos = pos + 1
4120             END IF
4130     END SELect
4140     first = 0
4150   END REPeat loop
4160   PRINT
4170   RETurn default$
4180 END DEFine Accept$
4190 :
4200 DEFine PROCedure Pr_Error(SRING$)
4210   STRIP 2 : INK 7 : PRINT SRING$ : STRIP 7 : INK 0
4220 END DEFine Pr_Error
4230 :
4240 DEFine FuNction Select_It(info$,items$)
4250   LOCal it$(9,30)
4260   PAPER 7 : INK 0
4270   cnt = 0
4280   REPeat loop
4290     x = "\" INSTR info$
4300     IF x = 0 THEN EXIT loop
4310     PRINT info$(1 TO x-1)
4320     info$ = info$(x+1 TO)
4330   END REPeat loop
4340   PRINT info$;"> ";
4350   REPeat loop
4360     x = "\" INSTR items$
4370     IF x = 0 THEN EXIT loop
4380     it$(cnt) = items$(1 TO x-1)
4390     items$ = items$(x+1 TO)
4400     cnt = cnt + 1
4410   END REPeat loop
4420   it$(cnt) = items$
4430   chblk = CHBASE(#1) : STRIP 4
4440   xpos  = PEEK_W(chblk+34) DIV PEEK_W(chblk+38)
4450   ypos  = PEEK_W(chblk+36) DIV PEEK_W(chblk+40)
4460   x     = 0
4470   REPeat loop
4480     AT ypos,xpos : PRINT it$(x); : CLS 4
4490     CURSEN : key$ = INKEY$(#1,-1) : CURDIS
4500     key = CODE(key$)
4510     SELect ON key
4520       =27 : x = 27 : EXIT loop
4530       =32 : x = x + 1
4540       =10 : EXIT loop
4550       =192,208 : x = x - 1
4560       =200,216 : x = x + 1
4570     END SELect
4580     IF x < 0 THEN x = cnt
4590     IF x > cnt THEN x = 0
4600   END REPeat loop
4610   PRINT
4620   RETurn x
4630 END DEFine Select_It
